## API Report File for "@genesislcap/foundation-forms"

> Do not edit this file. It is a report generated by [API Extractor](https://api-extractor.com/).

```ts

import { Controller } from '@microsoft/fast-element';
import { DatasourceOptions } from '@genesislcap/foundation-comms';
import { DOMContainer } from '@genesislcap/foundation-utils';
import { ElementStyles } from '@microsoft/fast-element';
import { ErrorObject } from 'ajv';
import { ErrorTranslator } from '@jsonforms/core';
import { Expression } from '@genesislcap/foundation-criteria';
import { FASTElement } from '@microsoft/fast-element';
import { FoundationElement } from '@microsoft/fast-foundation';
import { FoundationLayoutContainer } from '@genesislcap/foundation-utils';
import { JsonFormsState } from '@jsonforms/core';
import { JSONSchema7 } from 'json-schema';
import { LayoutCacheContainer } from '@genesislcap/foundation-utils';
import { Logger } from '@genesislcap/foundation-logger';
import { OwnPropsOfControl } from '@jsonforms/core';
import { RankedTester } from '@jsonforms/core';
import { StatePropsOfControl } from '@jsonforms/core';
import { UISchemaElement } from '@jsonforms/core';
import { ViewTemplate } from '@microsoft/fast-element';

// @public
export type ArrayRendererOptions = {
    childUiSchema?: UiSchema;
};

// @public
export type CategorizationRendererOptions = {
    childElements?: UiSchema[];
};

// @public
export type ConnectedRenderersOptions = {
    async?: boolean;
    allOptionsResourceName?: string;
    datasourceConfig?: DatasourceOptions;
    valueField?: string;
    labelField?: string;
    data?: any[];
};

// Warning: (ae-forgotten-export) The symbol "Expressions" needs to be exported by the entry point index.d.ts
//
// @public
export const createExpressions: (payload: any) => Expressions;

// @beta
export class Filters extends FoundationElement {
    // (undocumented)
    clearFiltersData(): void;
    // @public
    data: any;
    // (undocumented)
    disconnectedCallback(): void;
    // @public
    jsonSchema: JSONSchema7;
    // @internal (undocumented)
    onChange(event: CustomEvent): void;
    // @public
    renderers: RendererEntry[];
    // @public
    resourceName: string;
    // @internal (undocumented)
    searchFilters(): void;
    // @public
    uischema: UISchemaElement;
    // @public
    value: string;
    // (undocumented)
    valueChanged(): void;
}

// Warning: (ae-internal-missing-underscore) The name "filtersLogger" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal (undocumented)
export const filtersLogger: Logger;

// @public (undocumented)
export const filtersRenderers: any[];

// Warning: (ae-forgotten-export) The symbol "Form_base" needs to be exported by the entry point index.d.ts
//
// @beta
export class Form extends Form_base {
    // @public
    data: any;
    // @internal (undocumented)
    deepClone(): Node;
    // (undocumented)
    disconnectedCallback(): void;
    // (undocumented)
    hideSubmit: boolean;
    // (undocumented)
    get isSubmitHidden(): boolean;
    // @public
    jsonSchema: JSONSchema7;
    // @internal (undocumented)
    onChange(event: CustomEvent): void;
    // @public
    prefix: string;
    // (undocumented)
    readonly: boolean;
    // @public
    renderers: RendererEntry[];
    // @public
    reset(clearData?: boolean): void;
    // @public
    resourceName: string;
    // @internal (undocumented)
    _submit(): Promise<void>;
    // @internal (undocumented)
    submitPart(event: CustomEvent): void;
    // @internal (undocumented)
    submitted: boolean;
    // @internal (undocumented)
    submitting: boolean;
    // @public
    uischema: UISchemaElement;
}

// Warning: (ae-internal-missing-underscore) The name "foundationFormStyles" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal (undocumented)
export const foundationFormStyles: ElementStyles;

// Warning: (ae-internal-missing-underscore) The name "foundationFormTemplate" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal (undocumented)
export const foundationFormTemplate: ViewTemplate<Form, any>;

// @public (undocumented)
export const genesisErrorTranslator: ErrorTranslator;

// Warning: (ae-internal-missing-underscore) The name "getPrefixedForm" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal (undocumented)
export const getPrefixedForm: (prefix: any) => ViewTemplate<Form, any>;

// @public
export type GroupRendererOptions = CategorizationRendererOptions;

// Warning: (ae-internal-missing-underscore) The name "logger" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal (undocumented)
export const logger: Logger;

// @public
export const mustMatch: (target: string) => (data: any, path: any, label: any) => {
    instancePath: string;
    message: string;
    schemaPath: string;
    keyword: string;
    params: {};
}[];

// @public (undocumented)
export type RendererEntry = {
    renderer: ViewTemplate<DispatchRenderer, any>;
    tester: RankedTester;
    mapper: (state: JsonFormsState, ownProps: OwnPropsOfControl) => StatePropsOfControl;
};

// @public (undocumented)
export const renderers: any[];

// @public
export type StandardRendererOptions = {
    hidden?: boolean;
    validateFn?: (data: any, path: string, label: string) => ErrorObject[];
    i18n?: {
        [key: string]: any;
    };
};

// @public
export type StepperOrientationOptions = {
    orientation?: StepperOrientationType;
};

// @public
export type StepperOrientationType = 'vertical' | 'horizontal';

// @public
export type StepperRendererOptions = CategorizationRendererOptions;

// @public
export type StringRendererOptions = {
    isPassword?: boolean;
    textarea?: boolean;
};

// @public
export type UiSchema = {
    type: UiSchemaElementType;
    elements: UiSchemaElement[];
    options?: StepperOrientationOptions;
};

// @public
export type UiSchemaElement = {
    type: UiSchemaElementType;
    scope: string;
    label?: string;
    placeholder?: string;
    options?: UiSchemaElementOptions;
};

// @public
export type UiSchemaElementOptions = ConnectedRenderersOptions | ArrayRendererOptions | CategorizationRendererOptions | GroupRendererOptions | StepperRendererOptions | StringRendererOptions | StandardRendererOptions;

// @public
export type UiSchemaElementType = 'Control' | 'VerticalLayout' | 'LayoutVertical2Columns' | 'Categorization' | 'Group' | 'Stepper' | 'HorizontalLayout';

// Warnings were encountered during analysis:
//
// src/types.ts:226:3 - (ae-forgotten-export) The symbol "DispatchRenderer" needs to be exported by the entry point index.d.ts

// (No @packageDocumentation comment for this package)

```
